diff -rNci gcc-2.7.2/loop.c gcc-2.7.2p/loop.c
*** gcc-2.7.2/loop.c	Tue Oct  3 16:17:16 1995
--- gcc-2.7.2p/loop.c	Tue Jan 23 09:25:29 1996
***************
*** 2546,2573 ****
  	 mark this LABEL_REF so we know that this branch should predict
  	 false.  */
  
!       /* A check to make sure the label is not in an inner nested loop,
! 	 since this does not count as a loop exit.  */
!       if (dest_loop != -1)
! 	{
! 	  for (outer_loop = dest_loop; outer_loop != -1;
! 	       outer_loop = loop_outer_loop[outer_loop])
! 	    if (outer_loop == loop_num)
! 	      break;
! 	}
!       else
! 	outer_loop = -1;
! 
!       if (loop_num != -1 && outer_loop == -1)
  	{
  	  LABEL_OUTSIDE_LOOP_P (x) = 1;
  	  LABEL_NEXTREF (x) = loop_number_exit_labels[loop_num];
  	  loop_number_exit_labels[loop_num] = x;
- 
- 	  for (outer_loop = loop_num;
- 	       outer_loop != -1 && outer_loop != dest_loop;
- 	       outer_loop = loop_outer_loop[outer_loop])
- 	    loop_number_exit_count[outer_loop]++;
  	}
  
        /* If this is inside a loop, but not in the current loop or one enclosed
--- 2908,2918 ----
  	 mark this LABEL_REF so we know that this branch should predict
  	 false.  */
  
!       if (dest_loop != loop_num && loop_num != -1)
  	{
  	  LABEL_OUTSIDE_LOOP_P (x) = 1;
  	  LABEL_NEXTREF (x) = loop_number_exit_labels[loop_num];
  	  loop_number_exit_labels[loop_num] = x;
  	}
  
        /* If this is inside a loop, but not in the current loop or one enclosed
***************
*** 2593,2599 ****
--- 2938,2953 ----
  		     "\nLoop at %d ignored due to multiple entry points.\n",
  		     INSN_UID (loop_number_loop_starts[dest_loop]));
  	  
+ 	  /* intel1
+ 	     If doing loop_spl we don't care if there are multiple jumps
+ 	     to the loop entry label.  */
+ 	  if (!doing_spl 
+ 	      || NEXT_INSN (loop_number_loop_starts[dest_loop]) 
+ 	           != XEXP (x, 0))
+ 	  {
+ 	    
  	  loop_invalid[dest_loop] = 1;
+ 	  }
  	}
        return;
  
***************
*** 2624,2636 ****
  	 as a branch out of this loop, but not into any loop.  */
  
        if (loop_num != -1)
! 	{
! 	  loop_number_exit_labels[loop_num] = x;
  
- 	  for (outer_loop = loop_num; outer_loop != -1;
- 	       outer_loop = loop_outer_loop[outer_loop])
- 	    loop_number_exit_count[outer_loop]++;
- 	}
        return;
      }
  }
--- 2978,2985 ----
  	 as a branch out of this loop, but not into any loop.  */
  
        if (loop_num != -1)
! 	loop_number_exit_labels[loop_num] = x;
  
        return;
      }
  }
***************
*** 2818,2824 ****
    return 1 + conditional;
  }
  
- 
  /* Return nonzero if all the insns in the loop that set REG
     are INSN and the immediately following insns,
     and if each of those insns sets REG in an invariant way
--- 3167,3172 ----
***************
*** 3047,3052 ****
--- 3395,3416 ----
  		    may_not_move[regno] = 1;
  		  if (n_times_set[regno] < 127)
  		    ++n_times_set[regno];
+ 		  /* intel1 */
+ 		  if (doing_loop_after_global 
+ 		     && HARD_REGNO_NREGS (regno, GET_MODE (dest)) > 1)
+ 		    { /* Count each hard reg in the group.  */
+ 		        register int i,next_regno;
+ 
+ 		        i = HARD_REGNO_NREGS (regno, GET_MODE (dest));
+ 		        next_regno = regno + 1;
+ 		        while (i!=1)
+ 		          {
+ 		              if (n_times_set[next_regno] < 127)
+ 		                ++n_times_set[next_regno];
+ 		              next_regno++;
+ 		              i--;
+ 		          }
+ 		    }
  		  last_set[regno] = insn;
  		}
  	    }
***************
*** 3244,3249 ****
--- 3608,3616 ----
    int call_seen;
    rtx test;
    rtx end_insert_before;
+   int try_compare_elimination, done_compare_elimination; /* intel1 */
+   rtx compare_insn, jump_insn, tinsn; /* intel1 */
+   int *times_reg_used; /* intel1 */
    int loop_depth = 0;
  
    reg_iv_type = (enum iv_mode *) alloca (max_reg_before_loop
***************
*** 3373,3379 ****
  	     will be executed if the loop is executed.  */
  	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
  		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
! 		    || (NEXT_INSN (p) == loop_end && condjump_p (p)))))
  	not_every_iteration = 1;
  
        else if (GET_CODE (p) == NOTE)
--- 3740,3749 ----
  	     will be executed if the loop is executed.  */
  	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
  		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
!           || (NEXT_INSN (p) == loop_end && condjump_p (p))))
!      /*intel1*/  && !(GET_CODE (p) == JUMP_INSN
!                       && jumps_back_in_loop(p,loop_start,0,0))
!     )
  	not_every_iteration = 1;
  
        else if (GET_CODE (p) == NOTE)
***************
*** 3487,3492 ****
--- 3857,3874 ----
  	}
      }
  
+   /* Now see if it is wothwhile to do compare elimination, remember it only
+      saves one instruction.  intel1
+   */
+   try_compare_elimination = 0;
+   if (flag_compare_elim 
+      && loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]] == NULL)
+   {
+     possible_compare_elimination(loop_start, loop_end, &compare_insn, 
+                                  &jump_insn, &try_compare_elimination);
+     done_compare_elimination = 0;
+   }
+ 
    /* Look at the each biv and see if we can say anything better about its
       initial value from any initializing insns set up above.  (This is done
       in two passes to avoid missing SETs in a PARALLEL.)  */
***************
*** 3508,3513 ****
--- 3890,3910 ----
  	   || GET_MODE (src) == VOIDmode)
  	  && valid_initial_value_p (src, bl->init_insn, call_seen, loop_start))
  	{
+ 	  /* intel1 */
+ 	  if (flag_compare_elim && !flag_unroll_loops 
+ 	     && try_compare_elimination && !done_compare_elimination 
+ 	     && bl->biv_count == 1 
+ 	     && bl->biv->mult_val == const1_rtx 
+ 	     && REGNO (XEXP (SET_SRC (PATTERN (compare_insn)), 0)) == bl->regno 
+ 	     &&  (done_compare_elimination 
+ 	     = compare_elimination (bl, loop_start, loop_end, 
+ 	                         compare_insn, jump_insn,0)))
+ 	    {
+     	      rtx tem = find_reg_note (bl->init_insn, REG_EQUAL, 0);
+ 	      if (tem)
+ 		XEXP (tem, 0) = SET_SRC (bl->init_set);
+ 	      src = SET_SRC (bl->init_set);
+ 	    }
  	  bl->initial_value = src;
  
  	  if (loop_dump_stream)
***************
*** 3651,3657 ****
  	     will be executed if the loop is executed.  */
  	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
  		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
! 		    || (NEXT_INSN (p) == loop_end && condjump_p (p)))))
  	not_every_iteration = 1;
  
        else if (GET_CODE (p) == NOTE)
--- 4048,4057 ----
  	     will be executed if the loop is executed.  */
  	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
  		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
!           || (NEXT_INSN (p) == loop_end && condjump_p (p))))
!      /*intel1*/ && !(GET_CODE (p) == JUMP_INSN
!                      && jumps_back_in_loop(p,loop_start,0,0))
!     )
  	not_every_iteration = 1;
  
        else if (GET_CODE (p) == NOTE)
***************
*** 3717,3722 ****
--- 4117,4128 ----
    for (bl = loop_iv_list; bl; bl = bl->next)
      {
        struct induction *v;
+       /* intel1 */
+ #ifdef SAVE_ON_REGS
+       int num_add_vals_live_outside =0;
+       int no_mem_givs = 0;
+       int contains_loop =0;
+ #endif
        int benefit;
        int all_reduced;
        rtx final_value = 0;
***************
*** 3774,3779 ****
--- 4180,4276 ----
  	 We can't (currently) eliminate the biv unless this is so.  */
        all_reduced = 1;
  
+       /* intel1 */
+ #ifdef SAVE_ON_REGS
+       /* Only reduce DEST_ADDR givs of this biv if they will not increase
+          register pressure.  
+       */
+       if (!flag_all_mem_givs && flag_opt_reg_use)
+         {
+           int num_mult_val_saved = 0;
+           int num_givs_to_update = 0;
+           num_add_vals_live_outside = 0;
+           no_mem_givs = 0;
+           contains_loop = loop_contains_loop (loop_start, end);
+         
+           for (v = bl->giv; v; v = v->next_iv)
+             {
+               if (v->giv_type == DEST_ADDR)
+                 num_mult_val_saved++;
+               if (v->giv_type == DEST_ADDR && !v->same)
+                 {
+                   num_givs_to_update++;
+                   if (v->add_val && GET_CODE (v->add_val) == REG 
+                      && REGNO (v->add_val) >= FIRST_PSEUDO_REGISTER 
+                      && (contains_loop 
+                          || REGNO (v->add_val)<max_reg_before_loop))
+                     {
+                       if (loop_dump_stream 
+                          && reg_live_outside_loop[REGNO (v->add_val)])
+                         {
+                           fprintf (loop_dump_stream, 
+                           "dest addr giv at %d has add_val live outside reg%d\n", 
+                           INSN_UID (v->insn), REGNO (v->add_val));
+                         }
+                       if (contains_loop)
+                         num_add_vals_live_outside += 2;
+                       else
+                         {
+                           num_add_vals_live_outside += 
+                             reg_live_outside_loop[REGNO (v->add_val)];
+                         }
+                     }
+                   else if (v->add_val && GET_CODE (v->add_val) == CONST_INT 
+                            && v->mult_val == const1_rtx)
+                     { /* Disable this reduction. */
+                       num_add_vals_live_outside = (1 << ((sizeof (int)*8)-4));
+                     }
+                 }
+             }
+ #ifdef MAX_DEST_ADDR_GIVS
+         if (num_givs_to_update > MAX_DEST_ADDR_GIVS)
+           {
+             no_mem_givs = 1;
+           }
+ #endif
+         /* Heuristic here:
+            a) If the biv is eliminated that saves one register in the loop.  
+            b) Each giv_to_update must be updated at the end of the loop.  
+            c) Each add_val_live_outside may cause a spill somewhere.  
+         */
+         if (loop_dump_stream)
+           {
+             fprintf (loop_dump_stream,
+             "eliminable %d num_updates %d mults_saved %d adds_outside %d heu %d\n",
+             bl->eliminable, num_givs_to_update, num_mult_val_saved,
+             num_add_vals_live_outside,
+             (((int)(bl->eliminable) * -3) 
+              + (num_givs_to_update+((int)(bl->eliminable) * -1)) 
+              + (num_mult_val_saved*-1) +
+              + (num_add_vals_live_outside*3) 
+             ));
+           }
+         if (no_mem_givs 
+             ||  
+             (((int)(bl->eliminable) * -3) 
+              + (num_givs_to_update+((int)(bl->eliminable) * -1)) 
+              + (num_mult_val_saved*-1) +
+              + (num_add_vals_live_outside*3) > 0
+             )
+            )
+           {
+             all_reduced = 0;
+             for (v = bl->giv; v; v = v->next_iv)
+               {
+                 if (v->giv_type == DEST_ADDR)
+                   {
+                     v->ignore = 1;
+                   }
+               }
+           }
+       }
+ #endif /* SAVE_ON_REGS */
+ 
        /* Check each giv in this class to see if we will benefit by reducing
  	 it.  Skip giv's combined with others.  */
        for (v = bl->giv; v; v = v->next_iv)
***************
*** 3965,3971 ****
  		 loop to ensure that it will always be executed no matter
  		 how the loop exits.  Otherwise, emit the insn after the loop,
  		 since this is slightly more efficient.  */
! 	      if (loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]])
  		insert_before = loop_start;
  	      else
  		insert_before = end_insert_before;
--- 4462,4468 ----
  		 loop to ensure that it will always be executed no matter
  		 how the loop exits.  Otherwise, emit the insn after the loop,
  		 since this is slightly more efficient.  */
! 	      if (loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]])
  		insert_before = loop_start;
  	      else
  		insert_before = end_insert_before;
***************
*** 4032,4037 ****
--- 4529,4542 ----
  	 of the occurrences of the biv with a giv, but no harm was done in
  	 doing so in the rare cases where it can occur.  */
  
+       /* intel1 Retry compare elimination this time for loop trip test.  */
+       if (flag_compare_elim && !flag_unroll_loops 
+          && !done_compare_elimination && bl->retry_celim > 1 
+          && all_reduced == 1 && bl->eliminable)
+         {
+ 	  compare_elimination (bl, loop_start, loop_end, 
+                           compare_insn, jump_insn, 1);
+         } 
        if (all_reduced == 1 && bl->eliminable
  	  && maybe_eliminate_biv (bl, loop_start, end, 1,
  				  threshold, insn_count))
***************
*** 4057,4063 ****
  		 loop to ensure that it will always be executed no matter
  		 how the loop exits.  Otherwise, emit the insn after the
  		 loop, since this is slightly more efficient.  */
! 	      if (loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]])
  		insert_before = loop_start;
  	      else
  		insert_before = end_insert_before;
--- 4562,4568 ----
  		 loop to ensure that it will always be executed no matter
  		 how the loop exits.  Otherwise, emit the insn after the
  		 loop, since this is slightly more efficient.  */
! 	      if (loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]])
  		insert_before = loop_start;
  	      else
  		insert_before = end_insert_before;
***************
*** 4083,4088 ****
--- 4588,4606 ----
  	    fprintf (loop_dump_stream, "Reg %d: biv eliminated\n",
  		     bl->regno);
  	}
+       /* intel1 Retry compare elimination this time handling ashifhts. */
+       else if (flag_compare_elim && !flag_unroll_loops 
+                && !done_compare_elimination && bl->retry_celim == 1)
+         {
+ 	  if (compare_elimination (bl, loop_start, loop_end, 
+ 	                         compare_insn, jump_insn, 1))
+ 	    {
+     	      rtx tem = find_reg_note (bl->init_insn, REG_EQUAL, 0);
+ 	      if (tem)
+ 		XEXP (tem, 0) = SET_SRC (bl->init_set);
+  	      bl->initial_value = SET_SRC (bl->init_set);;
+ 	    }
+         } 
      }
  
    /* Go through all the instructions in the loop, making all the
***************
*** 4164,4169 ****
--- 4682,4689 ----
    register int i, j;
    register enum rtx_code code;
    register char *fmt;
+   /* intel1 */
+   rtx tx;
  
    if (x == 0)
      return;
***************
*** 4195,4200 ****
--- 4715,4738 ----
  	benefit = general_induction_var (XEXP (x, 0),
  					 &src_reg, &add_val, &mult_val);
  
+ 	/* intel1
+ 	   For now lets strip off consty and try to recoginze the result
+ 	   as a possible mem_giv.  */
+ #ifdef REWRITE_ADDRESS
+ 	if (flag_opt_reg_use
+ 	   && benefit == 0 && GET_CODE (XEXP (x, 0)) == PLUS 
+ 	   && GET_CODE (XEXP (XEXP (x, 0), 0)) == PLUS 
+ 	   &&  (GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT 
+ 	    || GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST 
+ 	    || GET_CODE (XEXP (XEXP (x, 0), 1)) == SYMBOL_REF))
+ 	  {
+ 	    tx = x;
+ 	    x = XEXP (x, 0);
+ 	    benefit = general_induction_var (XEXP (x, 0),
+                                              &src_reg, &add_val, &mult_val);
+ 	  }
+ #endif
+ 
  	/* Don't make a DEST_ADDR giv with mult_val == 1 && add_val == 0.
  	   Such a giv isn't useful.  */
  	if (benefit > 0 && (mult_val != const1_rtx || add_val != const0_rtx))
***************
*** 4203,4208 ****
--- 4741,4765 ----
  	    struct induction *v
  	      = (struct induction *) oballoc (sizeof (struct induction));
  
+ /* intel1 */
+ #ifdef REDUCE_INDEX
+ #ifdef REWRITE_ADDRESS
+ #ifdef LEGITIMATE_INDEX_P
+ 	rtx * index_part;
+ 	/* try to eliminate index terms */		
+ 	if (REDUCE_INDEX && flag_reduce_index_givs
+ 	   && do_reduce_index (x, &add_val))
+ 	  { 
+ 	    index_part = &XEXP (XEXP (x, 0), 0);
+ 	    record_giv (v, insn, src_reg, addr_placeholder, mult_val,
+ 	               add_val, benefit, DEST_ADDR, not_every_iteration,
+ 	               index_part, loop_start, loop_end);
+ 	    v->is_index_induc = 1;
+ 	  }
+ 	else
+ #endif
+ #endif
+ #endif
  	    record_giv (v, insn, src_reg, addr_placeholder, mult_val,
  			add_val, benefit, DEST_ADDR, not_every_iteration,
  			&XEXP (x, 0), loop_start, loop_end);
***************
*** 4290,4295 ****
--- 4847,4854 ----
        bl->eliminable = 0;
        bl->nonneg = 0;
        bl->reversed = 0;
+       /* intel1 */
+       bl->retry_celim = 0;
        bl->total_benefit = 0;
  
        /* Add this class to loop_iv_list.  */
***************
*** 4374,4379 ****
--- 4933,4942 ----
    v->new_reg = 0;
    v->final_value = 0;
    v->same_insn = 0;
+   /* intel1 */
+ #ifdef REDUCE_INDEX
+   v->is_index_induc = 0;
+ #endif
  
    /* The v->always_computable field is used in update_giv_derive, to
       determine whether a giv can be used to derive another giv.  For a
***************
*** 4651,4657 ****
  
  	      if (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p)
  		  && LABEL_NAME (JUMP_LABEL (p))
! 		  && ((INSN_LUID (JUMP_LABEL (p)) < INSN_LUID (v->insn)
  		       && INSN_LUID (JUMP_LABEL (p)) > INSN_LUID (loop_start))
  		      || (INSN_LUID (JUMP_LABEL (p)) > INSN_LUID (last_giv_use)
  			  && INSN_LUID (JUMP_LABEL (p)) < INSN_LUID (loop_end))))
--- 5214,5221 ----
  
  	      if (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p)
  		  && LABEL_NAME (JUMP_LABEL (p))
! 		  && ( INSN_UID(v->insn)>=max_uid_for_loop /* intel1 */
! 		      || (INSN_LUID (JUMP_LABEL (p)) < INSN_LUID (v->insn)
  		       && INSN_LUID (JUMP_LABEL (p)) > INSN_LUID (loop_start))
  		      || (INSN_LUID (JUMP_LABEL (p)) > INSN_LUID (last_giv_use)
  			  && INSN_LUID (JUMP_LABEL (p)) < INSN_LUID (loop_end))))
***************
*** 5474,5482 ****
       the expression of G2 in terms of G1 can be used.  */
    if (g2->giv_type == DEST_ADDR
        && (tem = express_from (g1, g2)) != 0
        && memory_address_p (g2->mem_mode, tem)
!       && ADDRESS_COST (tem) <= ADDRESS_COST (*g2->location))
      {
        g2->new_reg = tem;
        return 1;
      }
--- 6038,6063 ----
       the expression of G2 in terms of G1 can be used.  */
    if (g2->giv_type == DEST_ADDR
        && (tem = express_from (g1, g2)) != 0
+ /* intel1 */
+ #ifdef REDUCE_INDEX
+       && ((g2->is_index_induc && LEGITIMATE_INDEX_P(tem)) 
+            || (g2->is_index_induc == 0 && memory_address_p (g2->mem_mode, tem)
+            && ADDRESS_COST (tem) <= ADDRESS_COST (*g2->location))
+          )
+ #else
        && memory_address_p (g2->mem_mode, tem)
!       && ADDRESS_COST (tem) <= ADDRESS_COST (*g2->location)
! #endif
!      )
      {
+ /* intel1 */
+ #ifdef SAVE_ON_REGS
+       
+       if (flag_opt_reg_use && ADDRESS_COST (tem) != 1)
+       {
+         return(0);
+       }
+ #endif
        g2->new_reg = tem;
        return 1;
      }
***************
*** 5772,5778 ****
  	  num_nonfixed_reads += count_nonfixed_reads (PATTERN (p));
  
        if (bl->giv_count == 0
! 	  && ! loop_number_exit_count[uid_loop_num[INSN_UID (loop_start)]])
  	{
  	  rtx bivreg = regno_reg_rtx[bl->regno];
  
--- 6353,6359 ----
  	  num_nonfixed_reads += count_nonfixed_reads (PATTERN (p));
  
        if (bl->giv_count == 0
! 	  && ! loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]])
  	{
  	  rtx bivreg = regno_reg_rtx[bl->regno];
  
***************
*** 6274,6279 ****
--- 6855,6869 ----
        for (v = bl->giv; v; v = v->next_iv)
  	if (v->giv_type == DEST_ADDR && v->location == &XEXP (x, 0))
  	  return 1;
+ /* intel1 */
+ #ifdef REDUCE_INDEX
+ #ifdef LEGITIMATE_INDEX_P
+       for (v = bl->giv; v; v = v->next_iv)
+ 	if (REDUCE_INDEX && v->giv_type == DEST_ADDR && v->is_index_induc 
+ 	    && v->location == &XEXP (XEXP(x,0), 0))
+ 	  return 1;
+ #endif
+ #endif
        break;
      }
  
diff -rNci gcc-2.7.2/loop.h gcc-2.7.2p/loop.h
*** gcc-2.7.2/loop.h	Fri Jul 14 12:23:28 1995
--- gcc-2.7.2p/loop.h	Tue Jan 23 09:25:29 1996
***************
*** 88,93 ****
--- 88,97 ----
    unsigned maybe_dead : 1;	/* 1 if this giv might be dead.  In that case,
  				   we won't use it to eliminate a biv, it
  				   would probably lose. */
+ #ifdef REDUCE_INDEX
+   unsigned is_index_induc:1; /* 1 if this is actually the index portion
+                                 of a DEST_ADDR g_type intel1 */
+ #endif
    int lifetime;			/* Length of life of this giv */
    int times_used;		/* # times this giv is used. */
    rtx derive_adjustment;	/* If nonzero, is an adjustment to be
***************
*** 133,138 ****
--- 137,144 ----
    unsigned nonneg : 1;		/* 1 if we added a REG_NONNEG note for this. */
    unsigned reversed : 1;	/* 1 if we reversed the loop that this
  				   biv controls. */
+   unsigned retry_celim :2; /*intel1 is >0 if we should retry compare 
+                              elimination at the end of strength reduction */
  };
  
  /* Definitions used by the basic induction variable discovery code.  */
***************
*** 146,152 ****
  extern int *uid_loop_num;
  extern int *loop_outer_loop;
  extern rtx *loop_number_exit_labels;
- extern int *loop_number_exit_count;
  extern unsigned HOST_WIDE_INT loop_n_iterations;
  extern int max_reg_before_loop;
  
--- 152,157 ----
diff -rNci gcc-2.7.2/obstack.c gcc-2.7.2p/obstack.c
*** gcc-2.7.2/obstack.c	Sun Nov 26 19:57:12 1995
--- gcc-2.7.2p/obstack.c	Thu Jun 15 22:12:08 1995
***************
*** 17,46 ****
  
  #include "obstack.h"
  
! /* NOTE BEFORE MODIFYING THIS FILE: This version number must be
!    incremented whenever callers compiled using an old obstack.h can no
!    longer properly call the functions in this obstack.c.  */
! #define OBSTACK_INTERFACE_VERSION 1
  
  /* Comment out all this code if we are using the GNU C Library, and are not
!    actually compiling the library itself, and the installed library
!    supports the same library interface we do.  This code is part of the GNU
!    C Library, but also included in many other GNU distributions.  Compiling
     and linking in this code is a waste when using the GNU C library
     (especially if it is a shared library).  Rather than having every GNU
!    program understand `configure --with-gnu-libc' and omit the object
!    files, it is simpler to just do this in the source for each such file.  */
  
! #include <stdio.h>		/* Random thing to get __GNU_LIBRARY__.  */
! #if !defined (_LIBC) && defined (__GNU_LIBRARY__) && __GNU_LIBRARY__ > 1
! #include <gnu-versions.h>
! #if _GNU_OBSTACK_INTERFACE_VERSION == OBSTACK_INTERFACE_VERSION
! #define ELIDE_CODE
! #endif
! #endif
! 
! 
! #ifndef ELIDE_CODE
  
  
  #if defined (__STDC__) && __STDC__
--- 17,34 ----
  
  #include "obstack.h"
  
! /* This is just to get __GNU_LIBRARY__ defined.  */
! #include <stdio.h>
  
  /* Comment out all this code if we are using the GNU C Library, and are not
!    actually compiling the library itself.  This code is part of the GNU C
!    Library, but also included in many other GNU distributions.  Compiling
     and linking in this code is a waste when using the GNU C library
     (especially if it is a shared library).  Rather than having every GNU
!    program understand `configure --with-gnu-libc' and omit the object files,
!    it is simpler to just do this in the source for each such file.  */
  
! #if defined (_LIBC) || !defined (__GNU_LIBRARY__)
  
  
  #if defined (__STDC__) && __STDC__
***************
*** 494,497 ****
  
  #endif /* 0 */
  
! #endif	/* !ELIDE_CODE */
--- 482,485 ----
  
  #endif /* 0 */
  
! #endif	/* _LIBC or not __GNU_LIBRARY__.  */
diff -rNci gcc-2.7.2/optabs.c gcc-2.7.2p/optabs.c
*** gcc-2.7.2/optabs.c	Sat Oct 21 22:16:13 1995
--- gcc-2.7.2p/optabs.c	Thu Jun 15 11:55:15 1995
***************
*** 3511,3517 ****
  	      /* The sign bit is not set.  Convert as signed.  */
  	      expand_float (target, from, 0);
  	      emit_jump_insn (gen_jump (label));
- 	      emit_barrier ();
  
  	      /* The sign bit is set.
  		 Convert to a usable (positive signed) value by shifting right
--- 3511,3516 ----
diff -rNci gcc-2.7.2/output.h gcc-2.7.2p/output.h
*** gcc-2.7.2/output.h	Fri Jul 14 12:02:05 1995
--- gcc-2.7.2p/output.h	Thu Jun 15 11:55:44 1995
***************
*** 376,386 ****
  
  extern int current_function_varargs;
  
- /* Nonzero if current function uses stdarg.h or equivalent.
-    Zero for functions that use varargs.h.  */
- 
- extern int current_function_stdarg;
- 
  /* Quantities of various kinds of registers
     used for the current function's args.  */
  
--- 376,381 ----
diff -rNci gcc-2.7.2/print-rtl.c gcc-2.7.2p/print-rtl.c
*** gcc-2.7.2/print-rtl.c	Thu Jun 15 11:56:24 1995
--- gcc-2.7.2p/print-rtl.c	Tue Jan 23 09:25:29 1996
***************
*** 231,236 ****
--- 231,246 ----
    fprintf (stderr, "\n");
  }
  
+ void
+ tdebug_rtx(x, file)
+ 	rtx x;
+ 	FILE *file;
+ {
+   outfile=file;
+   print_rtx(x);
+   fprintf(file, "\n");
+ }
+ 
  /* Count of rtx's to print with debug_rtx_list.
     This global exists because gdb user defined commands have no arguments.  */
  
diff -rNci gcc-2.7.2/real.c gcc-2.7.2p/real.c
*** gcc-2.7.2/real.c	Tue Aug 15 21:57:18 1995
--- gcc-2.7.2p/real.c	Thu Jun 15 11:57:39 1995
***************
*** 2635,2647 ****
       unsigned EMUSHORT *a, *b, *c;
  {
    unsigned EMUSHORT ai[NI], bi[NI];
!   int i, sign;
    EMULONG lt, lta, ltb;
  
- /* IEEE says if result is not a NaN, the sign is "-" if and only if
-    operands have opposite signs -- but flush -0 to 0 later if not IEEE.  */
-   sign = eisneg(a) ^ eisneg(b);
- 
  #ifdef NANS
  /* Return any NaN input. */
    if (eisnan (a))
--- 2635,2643 ----
       unsigned EMUSHORT *a, *b, *c;
  {
    unsigned EMUSHORT ai[NI], bi[NI];
!   int i;
    EMULONG lt, lta, ltb;
  
  #ifdef NANS
  /* Return any NaN input. */
    if (eisnan (a))
***************
*** 2659,2665 ****
        || (eisinf (a) && eisinf (b)))
      {
      mtherr ("ediv", INVALID);
!     enan (c, sign);
      return;
      }
  #endif
--- 2655,2661 ----
        || (eisinf (a) && eisinf (b)))
      {
      mtherr ("ediv", INVALID);
!     enan (c, eisneg (a) ^ eisneg (b));
      return;
      }
  #endif
***************
*** 2667,2680 ****
  #ifdef INFINITY
    if (eisinf (b))
      {
        einfin (c);
!       goto divsign;
      }
  /* Anything else over infinity is zero. */
    if (eisinf (a))
      {
        eclear (c);
!       goto divsign;
      }
  #endif
    emovi (a, ai);
--- 2663,2680 ----
  #ifdef INFINITY
    if (eisinf (b))
      {
+       if (eisneg (a) ^ eisneg (b))
+ 	*(c + (NE - 1)) = 0x8000;
+       else
+ 	*(c + (NE - 1)) = 0;
        einfin (c);
!       return;
      }
  /* Anything else over infinity is zero. */
    if (eisinf (a))
      {
        eclear (c);
!       return;
      }
  #endif
    emovi (a, ai);
***************
*** 2692,2698 ****
  	    }
  	}
        eclear (c);
!       goto divsign;
      }
   dnzro1:
  
--- 2692,2698 ----
  	    }
  	}
        eclear (c);
!       return;
      }
   dnzro1:
  
***************
*** 2706,2716 ****
  	      goto dnzro2;
  	    }
  	}
  /* Divide by zero is not an invalid operation.
     It is a divide-by-zero operation!   */
        einfin (c);
        mtherr ("ediv", SING);
!       goto divsign;
      }
   dnzro2:
  
--- 2706,2720 ----
  	      goto dnzro2;
  	    }
  	}
+       if (ai[0] == bi[0])
+ 	*(c + (NE - 1)) = 0;
+       else
+ 	*(c + (NE - 1)) = 0x8000;
  /* Divide by zero is not an invalid operation.
     It is a divide-by-zero operation!   */
        einfin (c);
        mtherr ("ediv", SING);
!       return;
      }
   dnzro2:
  
***************
*** 2718,2735 ****
    /* calculate exponent */
    lt = ltb - lta + EXONE;
    emdnorm (bi, i, 0, lt, 64);
!   emovo (bi, c);
! 
!  divsign:
! 
!   if (sign
! #ifndef IEEE
!       && (ecmp (c, ezero) != 0)
! #endif
!       )
!      *(c+(NE-1)) |= 0x8000;
    else
!      *(c+(NE-1)) &= ~0x8000;
  }
  
  /* Multiply e-types A and B, return e-type product C.   */
--- 2722,2733 ----
    /* calculate exponent */
    lt = ltb - lta + EXONE;
    emdnorm (bi, i, 0, lt, 64);
!   /* set the sign */
!   if (ai[0] == bi[0])
!     bi[0] = 0;
    else
!     bi[0] = 0Xffff;
!   emovo (bi, c);
  }
  
  /* Multiply e-types A and B, return e-type product C.   */
***************
*** 2739,2751 ****
       unsigned EMUSHORT *a, *b, *c;
  {
    unsigned EMUSHORT ai[NI], bi[NI];
!   int i, j, sign;
    EMULONG lt, lta, ltb;
  
- /* IEEE says if result is not a NaN, the sign is "-" if and only if
-    operands have opposite signs -- but flush -0 to 0 later if not IEEE.  */
-   sign = eisneg(a) ^ eisneg(b);
- 
  #ifdef NANS
  /* NaN times anything is the same NaN. */
    if (eisnan (a))
--- 2737,2745 ----
       unsigned EMUSHORT *a, *b, *c;
  {
    unsigned EMUSHORT ai[NI], bi[NI];
!   int i, j;
    EMULONG lt, lta, ltb;
  
  #ifdef NANS
  /* NaN times anything is the same NaN. */
    if (eisnan (a))
***************
*** 2763,2769 ****
        || (eisinf (b) && (ecmp (a, ezero) == 0)))
      {
      mtherr ("emul", INVALID);
!     enan (c, sign);
      return;
      }
  #endif
--- 2757,2763 ----
        || (eisinf (b) && (ecmp (a, ezero) == 0)))
      {
      mtherr ("emul", INVALID);
!     enan (c, eisneg (a) ^ eisneg (b));
      return;
      }
  #endif
***************
*** 2771,2778 ****
  #ifdef INFINITY
    if (eisinf (a) || eisinf (b))
      {
        einfin (c);
!       goto mulsign;
      }
  #endif
    emovi (a, ai);
--- 2765,2776 ----
  #ifdef INFINITY
    if (eisinf (a) || eisinf (b))
      {
+       if (eisneg (a) ^ eisneg (b))
+ 	*(c + (NE - 1)) = 0x8000;
+       else
+ 	*(c + (NE - 1)) = 0;
        einfin (c);
!       return;
      }
  #endif
    emovi (a, ai);
***************
*** 2790,2796 ****
  	    }
  	}
        eclear (c);
!       goto mulsign;
      }
   mnzer1:
  
--- 2788,2794 ----
  	    }
  	}
        eclear (c);
!       return;
      }
   mnzer1:
  
***************
*** 2805,2811 ****
  	    }
  	}
        eclear (c);
!       goto mulsign;
      }
   mnzer2:
  
--- 2803,2809 ----
  	    }
  	}
        eclear (c);
!       return;
      }
   mnzer2:
  
***************
*** 2814,2831 ****
    /* calculate exponent */
    lt = lta + ltb - (EXONE - 1);
    emdnorm (bi, j, 0, lt, 64);
!   emovo (bi, c);
! 
!  mulsign:
! 
!   if (sign
! #ifndef IEEE
!       && (ecmp (c, ezero) != 0)
! #endif
!       )
!      *(c+(NE-1)) |= 0x8000;
    else
!      *(c+(NE-1)) &= ~0x8000;
  }
  
  /* Convert double precision PE to e-type Y.  */
--- 2812,2823 ----
    /* calculate exponent */
    lt = lta + ltb - (EXONE - 1);
    emdnorm (bi, j, 0, lt, 64);
!   /* calculate sign of product */
!   if (ai[0] == bi[0])
!     bi[0] = 0;
    else
!     bi[0] = 0xffff;
!   emovo (bi, c);
  }
  
  /* Convert double precision PE to e-type Y.  */
diff -rNci gcc-2.7.2/recog.c gcc-2.7.2p/recog.c
*** gcc-2.7.2/recog.c	Sat Jul  1 10:52:35 1995
--- gcc-2.7.2p/recog.c	Thu Jun 15 11:58:34 1995
***************
*** 864,880 ****
  	 reg went on the stack.)  */
        if (! reload_completed && GET_CODE (SUBREG_REG (op)) == MEM)
  	return general_operand (op, mode);
- 
- #ifdef CLASS_CANNOT_CHANGE_SIZE
-       if (GET_CODE (SUBREG_REG (op)) == REG
- 	  && REGNO (SUBREG_REG (op)) < FIRST_PSEUDO_REGISTER
- 	  && TEST_HARD_REG_BIT (reg_class_contents[(int) CLASS_CANNOT_CHANGE_SIZE],
- 				REGNO (SUBREG_REG (op)))
- 	  && (GET_MODE_SIZE (mode)
- 	      != GET_MODE_SIZE (GET_MODE (SUBREG_REG (op)))))
- 	return 0;
- #endif
- 
        op = SUBREG_REG (op);
      }
  
--- 864,869 ----
